class Passbox.Routers.Pages extends Backbone.Router
	
	initialize: (options) ->
		
		# Refresh page if user's authorization has changed
		Passbox.user.bind "change:authorized", => @_refresh()
	
	
	# ROUTES
	
	routes:
		"/about"    : "about"
		"/settings" : "settingsOrLogin"
		"/*"        : "homeOrLogin"
	
	# VIEWS
	
	login: ->
		@login_view ||= new Passbox.Views.Pages.Login()
		@_render @login_view
		
	home: ->
		@admin_view ||= new Passbox.Views.Pages.Home()
		@_render @admin_view
		
	about: ->
		@about_view ||= new Passbox.Views.Pages.About()
		@_render @about_view
		
	settings: ->
		@settings_view ||= new Passbox.Views.Dialogs.Settings()
		@_render @settings_view
		
	# CONDITIONAL VIEWS
	
	homeOrLogin: ->
		if Passbox.user.isAuthorized() then @home() else @login()
	
	settingsOrLogin: ->
		if Passbox.user.isAuthorized() then @settings() else @login()
		
		
	# __PRIVATE__ Helpers
	
	_render: (view) ->
		$("#main, #overlay").html("").hide() # TODO: ugly, look to put it elsewhere
		view.render()
			
	_refresh: ->
		Backbone.history.loadUrl()