# Animated Page Transition
if $('html').hasClass('csstransitions')
	
	class Passbox.Routers.Pages extends Passbox.Routers.Pages
		
		_animation: true
		_animationDuration: 0.5 #seconds
		_animationTop: 50 #pixels
		_cssTransforms3d: $('html').hasClass('csstransforms3d')

		constructor: ->
			@_animationDurationMS = @_animationDuration * 1000
			super
		
		_slideIn: (el = '#container') ->
			if @_cssTransforms3d
				$(el)
					.anim( {opacity:0, translate3d: "0, -#{@_animationTop}px, 0"}, 0, '', =>
						$(el).anim({opacity:1, translate3d: '0, 0, 0'}, @_animationDuration, '', =>
							setTimeout( =>
								$(el).attr("style","")
							, @_animationDurationMS)
						)
					)
			else
				$(el)
					.css( {opacity:0, top:-@_animationTop})
					.anim({opacity:1, top: 0}, @_animationDuration, '', =>
						setTimeout( =>
							$(el).attr("style","")
						, @_animationDurationMS)
					)
					
		_slideOut: (callback, el = '#container') ->	

			if @_cssTransforms3d
				$(el)
					.attr("style","")
					.anim({opacity:0, translate3d: "0,-#{@_animationTop}px,0"}, @_animationDuration, '', callback)
			else
				$(el)
					.attr("style","")
					.anim({opacity:0, top: -@_animationTop}, @_animationDuration, '', callback)
				
			# 	# or if the callback triggers right away, try:
			# 	#
			# 	# =>
			# 	# 	setTimeout( =>
			# 	# 		callback()
			# 	# 	, 500)
			# 	# )
			# 	#  callback)
		
		_render: (args...) ->
			if not @_rendered_once
				@_renderAndSlideIn(args...)
			else
				@_slideOut => @_renderAndSlideIn(args...)
			@_rendered_once = true
		
		_renderAndSlideIn: (args...) ->
			Pages.__super__._render.apply(this, arguments);
			@_slideIn()
			
	# or alternatively do:
	#
	# _.extend Passbox.Routers.Pages.prototype,
	# 	
	# 	_animation_render__original__: 
	# 		Passbox.Routers.Pages::_render
	# 	
	# 	_render: (args...) ->
	# 		...