Passbox.Views.Dialogs ||= {}

class Passbox.Views.Dialogs.Settings extends Passbox.Views.Dialog
	template: JST["templates/pages/settings"]
	bodyClass: "settings"
	title: "Settings"

	id: "settings_page"
	
	events:
		# "click " : "save"
		"click #yes"     : "confirm"
		"click a.goBack" : "dismiss"
		"submit form": "save"
		
	initialize: ->


		super
		@success = @options.success
		@model = Passbox.user
	
	dismiss: (e) ->
		e.preventDefault()
		e.stopPropagation()
		Passbox.router._slideOut?(=>
			# window.history.back()
			Backbone.history.navigate('',true)
		, "#overlay")
			
	save: (e) ->
		e.preventDefault()
		e.stopPropagation()
		
		# validate inputs
		if @model.get("currentkey") is null
			return alert "Current password must not be empty."

		if !@model.get("newkey") or @model.get("newkey")?.length is 0
			alert "New password must not be empty."
			return
		
		if @model.get("newkey") != @model.get("repeat")
			return alert "Passwords do not match."
		
		if @model.get("currentkey") != @model.get("key")
			return alert "Your current password appears to be wrong."

		Passbox.user.passwords.fetch(
			success: =>
				# Next switch to newKey
				@model.unset("errors")
				@model.set("key":@model.get("newkey"))
				@model.unset("repeat")
				@model.unset("newkey")
				Passbox.user.passwords.save(
					success: ->
						# alert "success"
						Backbone.history.navigate('/',true)
				)
				
			error: (collection, resp, options) =>
				if resp == 'FileNotFound'
					alert "You need to create a master password first."
				else if resp == 'DecryptError'
					alert "Your current password is not correct."
		)

	render: ->
		$(this.el).html @template(@model.toJSON())

		super

		this.$("form").backboneLink(@model)
		