Passbox.Views.Layouts ||= {}

class Passbox.Views.Layouts.Header extends Backbone.View
	template: JST["templates/layouts/header"]
	el: "#header"
	
	events:
		"click #logout": "logout"
	
	initialize: ->
		Passbox.router.bind "route", => 
			@_markActiveLink(arguments...)
		
		@render()

	render:  ->
		$(@el).html(@template(user: Passbox.user))
		return this
		
	_markActiveLink: (fragment) ->
		this.$("a.active").removeClass("active")
		this.$("a[href='##{fragment}']").addClass("active")
		
	logout: (e) ->
		e.preventDefault()
		e.stopPropagation()
		
		$.ajax({
			url:  "/logout"
			cache: false
			dataType: "json"
			success: (data) ->
				Passbox.user.set({authorized:false, key:null})
				window.location.reload();
				return false

			error: ->
				alert "error"
				window.location.reload();
		});