eventSplitter = /^(\S+)\s*(.*)$/

class Passbox.Views.Page extends Backbone.View
	
	el: "#main"
	title: null
	bodyTxt: null
	
	# This is only to be called once by the view constructor
	delegateEvents: (events) ->
		if not (events or (events = @events)) then return

		newEvents = {}

		# Be more specific with our selectors by targetting the view cid
		for key, value of events
			[raw, eventName, selector] = key.match(eventSplitter)
			newEvents["#{eventName} [data-cid=#{@cid}] #{selector}"] = value

		@events = newEvents

		super @events

	render: ->
		# after-render
		$("#overlay").hide()
		$("#main").show()

		$(@el).attr("data-cid","#{@cid}")

		@_setTitle @title if @title
		$("body").attr "class", @bodyClass || "" if @bodyClass
		$("body").addClass "loggedIn" if Passbox.user.isAuthorized()
		return this
		
	_setTitle: (title) ->
		document.title = "#{title} | " if title?.length
		document.title += " Passbox"