Passbox.Views.Passwords ||= {}

class Passbox.Views.Passwords.Index extends Backbone.View
	template: JST["templates/passwords/index"]
	tagName: "section"
	className: "passwords"
		
	events:
		"keyup #searchField": "search"
		"click #searchField": "search"
		"click #new-btn"    : "newPassword"

	initialize: () ->
		_.bindAll(this, 'addOne', 'addAll', 'render')
		
		@collection.bind('reset', @addAll)
		@collection.bind('add', @addOne)
		@collection.bind("all", @renderStats)
		
		Passbox.user.bind "change:authorized", =>
			if !Passbox.user.isAuthorized() then @collection.reset()
		
	addAll: () ->
		@collection.each(@addOne)
		
	addOne: (password) ->
		view = new Passbox.Views.Passwords.Password({model : password})
		@$("ul").append(view.render().el)
	
	newPassword: (e) ->
		e.preventDefault()
		e.stopPropagation()
		@newpassword_view ||= new Passbox.Views.Passwords.New({collection: @collection})
		@newpassword_view.open()
	
	render: ->
		$(@el).html(@template( passwords: @collection.toJSON() ))
		@addAll()
		@renderStats()
		return this
		
	renderStats: =>
		$("#count").html(@collection.length || "")
		
	search: ->
		letters = $('#searchField').val()
		pattern = new RegExp(letters,"gi")
		
		$(@el).find("li").each ->
			text = $(this).find(".website").text() + " "+ $(this).find(".username").text()
			pattern.lastIndex = 0
			if pattern.test text
				$(this).show()
			else
				$(this).hide()
				