require 'dropbox_sdk'

class ApplicationController < ActionController::Base
	protect_from_forgery
	
	before_filter :set_cache_buster
	
	def index
		begin
			@authorized = DropboxSession.deserialize(session[:authorized_db_session]).authorized?
		rescue
			@authorized = false
		end
		render :template => 'layouts/application', :layout => nil
	end
	
	def set_cache_buster
		response.headers["Cache-Control"] = "no-cache, no-store, max-age=0, must-revalidate"
		response.headers["Pragma"] = "no-cache"
		response.headers["Expires"] = "Fri, 01 Jan 1990 00:00:00 GMT"
	end
end
