require 'dropbox_sdk'

class DbController2 < ApplicationController
	
	#before_filter :delay # for testing

	def authorize
		
			if not params[:oauth_token] then
					dbsession = DropboxSession.new(DROPBOX_CONFIG["APP_KEY"], DROPBOX_CONFIG["APP_SECRET"])
					
					session[:dropbox_session] = dbsession.serialize #serialize and save this DropboxSession
					
					# pass to get_authorize_url a callback url that will return the user here
					url = dbsession.get_authorize_url url_for(:action => 'authorize')
					render :json => {'status' => 'redirect', 'url' => url}
			else
					# the user has returned from Dropbox
					dbsession = DropboxSession.deserialize(session[:dropbox_session])
					dbsession.get_access_token	#we've been authorized, so now request an access_token
					session[:dropbox_session] = dbsession.serialize
					
					respond_to do |format|
						format.json { render :json => {'success' => true } }
						format.html { redirect_to '' }
					end
			end
	end
	
	def logout
		
		#TODO: does this belong here?
		session.delete :dropbox_session
		render :json => {'success' => true }
	end
 
	def push
		client = get_client()
		
		# def put_file(to_path, file_obj, overwrite=false, parent_rev=nils)
		resp = client.put_file(DROPBOX_CONFIG["DB_FILENAME"], request.raw_post, true)
		render :json => {'success' => true }
	end 
	
	def pull
		client = get_client()
		
		begin
			file = client.get_file(DROPBOX_CONFIG["DB_FILENAME"])
			
			# the file doesn't exist
			rescue DropboxError => err
				if err.error == "File has been deleted"
					render :text => ""
					return
					# file = "[]"
					# client.put_file(DROPBOX_CONFIG["DB_FILENAME"], file)
				else
					puts "ERROR: db_controller pull() new DropboxError discovered!"
				end
				
		end
		
		render :text => file
	end
	
	private
		def get_client
			
			# Check if user has no dropbox session...re-direct them to authorize
			return redirect_to(:action => 'authorize') unless session[:dropbox_session]
			
			dbsession = DropboxSession.deserialize(session[:dropbox_session])
			client = DropboxClient.new(dbsession, DROPBOX_CONFIG["ACCESS_TYPE"]) #raise an exception if session not authorized
			
			return client
		end
		
		def delay
			sleep(2.0)
		end
end
